function Connect2ChatConductor::AddLine(%this,%User,%Line,%SessionType,%Session)
{
	%Line = StripMlControlChars(%Line);
	
	%OnlineFriends = Connect2ChatConductor.GetOnlineFriends();
	
	//%AdminNormalBitmap = "<Bitmap:"@$C2C::IconPath@"AdminNormal>";
	%AdminPmBitmap = "<Bitmap:"@$C2C::IconPath@"AdminPm>";
	%PmBitmap = "<Bitmap:"@$C2C::IconPath@"PM>";
	%ErrorBitmap = "<Bitmap:"@$C2C::IconPath@"Error>";
	%NoticeBitmap = "<Bitmap:"@$C2C::IconPath@"Notice>";
	//%NormalBitmap = "<Bitmap:"@$C2C::IconPath@"Normal>";
	%RoomBitmap = "<Bitmap:"@$C2C::RTBIconPath@%Session.room.icon@">";

	if(%SessionType $= "RANKPMSG")
	{
		%Bitmap = %AdminPmBitmap;
		
		%Color1 = "<Color:0099FF>";
	}

	if(%SessionType $= "RANK")
	{
		%Bitmap = %RoomBitmap;
		
		%Color1 = "<Color:0099FF>";
	}

	if(%SessionType $= "PMSG")
	{
		%Bitmap = %PMBitmap;
	}
	else
	if(%SessionType $= "ERROR")
	{
		%Bitmap = %ErrorBitmap;
		
		%Color1 = "\c0";

		%User = "Error";
	}
	else
	if(%SessionType $= "Notice")
	{
		%Bitmap = %NoticeBitmap;
		
		%User = "Notice";
	}
	else
	if(%sessionType $= "ACTION")
	{
		%Bitmap = %RoomBitmap;
		
		%Color1 = "<Color:FF00FF>";
		%Color2 = %Color1;
	}
	else
	if(%sessionType $= "PACTION")
	{
		%sessionType = "ACTION";
		
		%Bitmap = %PmBitmap;
		
		%Color1 = "<Color:FF00FF>";
		%Color2 = %Color1;
	}

	if(%Bitmap $= "")
	{
		%Bitmap = %RoomBitmap;
	}
	
	if(%User $= connect2ChatConductor.Master && %SessionType !$= "ACTION")
	{
		%Color1 = "<color:ff9933>";
	}
	if(%Color1 $= "")
	{
		%Color1 = "\c3";
	}
	if(%Color2 $= "")
	{
		%Color2 = "\c6";
	}
	
	%Font = "<font:"@connect2ChatConductor.font@":"@connect2ChatConductor.fontSize@">";
	
	%Line = parseLinks(%Line);
	
	if(%SessionType $= "ACTION")
	{
		%Message = %Bitmap@%Font@%Color1@"* "@%User@%Color2@" "@%Line;
	}
	else
	{
		%Message = %Bitmap@%Font@%Color1@%User@"\c6 -"@%Color2@" "@%Line;
	}
	NewChatSo.AddLine(%Message);
}

function connect2ChatConductor::FontData(%this)
{
	if($RTB::Options::C2C::Font == 0)
		connect2ChatConductor.font = "Arial";
	else
	if($RTB::Options::C2C::Font == 1)
		connect2ChatConductor.font = "Comic Sans MS";
	else
	if($RTB::Options::C2C::Font == 2)
		connect2ChatConductor.font = "Impact";
	else
	if($RTB::Options::C2C::Font == 3)
		connect2ChatConductor.font = "Georgia";
		
	if($RTB::Options::C2C::FontSize == 0)
		connect2ChatConductor.FontSize = "15";
	else
	if($RTB::Options::C2C::FontSize == 1)
		connect2ChatConductor.FontSize = "20";
	else
	if($RTB::Options::C2C::FontSize == 2)
		connect2ChatConductor.FontSize = "25";
	else
	if($RTB::Options::C2C::FontSize == 3)
		connect2ChatConductor.FontSize = "30";
}

function Connect2ChatConductor::speak(%this,%message,%type)
{
	//%message = %this.speakTag[%type];
	
	echo(%type SPC %message);
}

function Connect2ChatConductor::isAvailable(%this,%sort)
{
	if(%sort $= "All")
	{
		if(isObject(newChatSo) && isObject(serverConnection) && $RTB::Options::C2C::Toggle)
			return true;
	}
	else
	if(%sort $= "ChatInterface")
	{
		if(isObject(newChatSo))
			return true;
	}
	else
	if(%sort $= "ServerConnection")
	{
		if(isObject(serverConnection))
			return true;
	}
	else
	if(%sort $= "Variable")
	{
		if($RTB::Options::C2C::Toggle)
			return true;
	}

	return 0;
}

function Connect2ChatConductor::GetOnlineFriends(%this)
{
	%Group = RTBCC_Roster.GetObject(0);
	
	%NameList = 0;
	
	if(IsObject(%Group))
	{
		%GroupCount = %Group.getCount();
		
		for(%i=0;%i<%groupCount;%i++)
		{
			%UserData = %Group.GetObject(%i);
			
			if(IsObject(%UserData))
			{
				if(%NameList $= "0")
				{
					%NameList = StrReplace(%UserData.Name," ","_");
				}
				else
				{
					%NameList = %NameList SPC StrReplace(%UserData.Name," ","_");
				}
			}
		}
	}
	return %NameList;
}

function Connect2ChatConductor::GeneralList_GetUserIdByName(%this,%name)
{
	%Name = StrLwr(StrReplace(%Name," ","_"));
	
	%RoomCount = RTBCC_RoomSessionManager.getCount();
	
	for(%j=0;%j<%RoomCount;%j++)
	{
		%Group = RTBCC_RoomSessionManager.getObject(%j).Manifest;
	
		if(IsObject(%Group))
		{
			%GroupCount = %Group.getCount();
			
			for(%i=0;%i<%GroupCount;%i++)
			{
				%UserData = %Group.GetObject(%i);
				
				if(IsObject(%UserData))
				{
					%UserName = StrLwr(%UserData.Name);
					%UserName = StrReplace(%UserName," ","_");
					
					if(StrStr(%UserName,%Name) >= 0)
					{
						return %UserData.ID;
					}
				}
			}
		}
	}
	return false;
}

function Connect2ChatConductor::GeneralList_GetObjectFromId(%this,%ID)
{
	%RoomCount = RTBCC_RoomSessionManager.getCount();
	
	for(%j=0;%j<%RoomCount;%j++)
	{
		%Group = RTBCC_roomSessionManager.getObject(%j).Manifest;
		if(IsObject(%Group))
		{
			%GroupCount = %Group.GetCount();
			
			for(%i=0;%i<%GroupCount;%i++)
			{
				%UserData = %Group.GetObject(%i);
				
				if(IsObject(%UserData))
				{
					if(%UserData.ID == %ID)
					{
						return %UserData;
					}
				}
			}
		}
	}
	return false;
}

function Connect2ChatConductor::FriendsList_GetUserIdByName(%this,%name)
{
	%Name = StrLwr(StrReplace(%Name," ","_"));
	
	%Group = RTBCC_Roster.GetObject(0);
	
	if(IsObject(%Group))
	{
		%GroupCount = %Group.GetCount();
		
		for(%i=0;%i<%GroupCount;%i++)
		{
			%UserData = %Group.GetObject(%i);
			
			if(IsObject(%UserData))
			{
				%UserName = StrReplace(%UserData.Name," ","_");
				
				if(StrStr(strLwr(%UserName),strLwr(%Name)) >= 0)
				{
					return %UserData.ID;
				}
			}
		}
	}
	return false;
}

function Connect2ChatConductor::FriendsList_GetUserNameById(%this,%Id)
{
	%Group = RTBCC_Roster.GetObject(0);
	
	if(IsObject(%Group))
	{
		%GroupCount = %Group.GetCount();
		
		for(%i=0;%i<%GroupCount;%i++)
		{
			%UserData = %Group.GetObject(%i);
			
			if(IsObject(%UserData))
			{
				if(%userData.ID == %Id)
					return %UserData.Name;
			}
		}
	}
	return false;
}

function connect2ChatConductor::RemoveNotificationByName(%this,%name)
{
	%notManager = RTBCC_NotificationManager;
	%name = strReplace(%name,"_"," ");
	
	if(!isObject(%notManager))
	{
		Connect2ChatConductor.speak("with trying to remove notifcation object by name. name => "@%name,"error");
		return 0;
	}
	
	for(%i=0;%i<%notManager.getCount();%i++)
	{
		%not = %notManager.getObject(%i);
		
		if(%not.title $= %name)
		{
			%key = %not.key;
			
			RTBCC_NotificationManager.pop(%key);
		}
	}
}

function C2CMH(%this)
{
	%room = RTBCC_RoomSessionManager.GetRoomByName(connect2ChatConductor.currentRoom);
	if(isObject(%room))
		%name = %room.name;
	else if(RTBCC_RoomSessionmanager.getCount() > 0) {
		connect2ChatConductor.currentRoom = RTBCC_RoomSessionmanager.getObject(0).name;
		%room = RTBCC_RoomSessionmanager.getObject(0);
		%name = connect2ChatConductor.currentRoom;
	}
	else
		%name = "N/A";

	//Opens the message hud
	NewMessageHud.Open(Say);
	
	//Sets the channel to RTB
	Nmh_Channel.SetText("C2C - " @ %name @ ":");
}

//Hack
function SetKeyBind()
{	
	Canvas.PushDialog(OptionsDlg);
	
	OptionsDlg.SetPane("Controls");
	
	%Obj = OptRemapList;
	
	if(!IsObject(%Obj))
	{
		Error("No such object = > "@%Obj@".");
		
		Canvas.PopDialog(OptionsDlg);
		
		return false;
	}
	%C = %Obj.RowCount();
	
	for(%i=0;%i<%C;%i++)
	{
		%ID = %Obj.GetRowID(%i);
		
		%Name = StripMlControlChars(%Obj.GetRowTextById(%ID));
		
		if(%Name $= "Open/Close message hud")
		{
			%Obj.SetSelectedRow(%i);
			%Obj.SetRowActive(%i,true);
			%Obj.DoRemap(%ID);
			
			MessageBoxOk("Connect 2 Chat keybind set","If you want to change the keybind for Connect 2 Chat, go to blockland's options then go to the controls tab and look for RTBConnect to Chat.");
			
			break;
		}
	}
	Canvas.PopDialog(OptionsDlg);
	return true;
}

function designScriptObject(%objName,%startVariables)
{
	if(%objName $= "")
	{
		error("Cannot design a script object without naming it. #ABORT");
		return 0;
	}
	
	%startVariables = strReplace(%startVariables,"&&"," ");
	
	if(%startVariables !$= "")
	{
		for(%i=0;%i<getWordCount(%startVariables);%i++)
		{
			%chunk[%i] = getWord(%startVariables,%i);
			
			if(%errorMessage $= "" && (%catch1 = strStr(%chunk[%i],"=") == -1 || %catch2 = strStr(%chunk[%i],";")) == -1)
			{
				%chunk[%i] = "ERROR";
				
				if(%catch1 $= "" && %catch2 $= "")
				{
					%errorMessage = "Starting variables must be be in this form. \"var1=1; var2=2;\.";
				}
			}
		}
	}
	
	if(%errorMessage !$= "")
		error(%errorMessage@"\nObject design completed anyways => "@%objName@".");
		
	%scriptObject = new scriptObject(%objName);
	
	%cc = %i;for(%i=0;%i<%cc;%i++)
	{
		%variable = %chunk[%i];
		
		if(%variable !$= "Error")
		{
			eval("%objname."@%chunk[%i]@"");
		}
	}
	return %scriptObject;
}
